from datetime import datetime
import time
import socket
import threading


def log(address, start_time, id, message):
        e = time.time() - start_time
        print "time={}, ip={}, id={}, alive={:.2f}, msg={}".format(str(datetime.now()),str(address),str(id),e,message)

def send(client, data):
        return client.send(data), data

class ThreadedServer(object):
    def __init__(self, host, port):
        self.host = host
        self.port = port
        self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        self.sock.bind((self.host, self.port))

    def listen(self):
        self.sock.listen(5)
        log(0,time.time(), 0,"Server is up\n\n")
        connection_count = 0
        while True:
            client, address = self.sock.accept()
            client.settimeout(500)
            threading.Thread(target = self.listenToClient,args = (client,address, connection_count)).start()
            connection_count += 1

    def listenToClient(self, client, address, id):
        times = []
        start_time = time.time()
        log(address, start_time, id, "Client connected")
        if 1: #try:
            data = client.recv(1024)
            if not data:
                log(address, start_time, id, "Client disconnected")
                return False
            #log(address, start_time, id, data)
            first_line,_ = data.split("\n",1)

            url = ""
            try:
               url = first_line.split()[1][1:]
               url = first_line.split("url=",1)[1].split(" ")[0].strip()
               wait = first_line.split("wait=",1)[1].split("&")[0].split(" ")[0].strip()
               wait = int(wait)
            except:
               wait = 0

            log(address, start_time, id, "request: wait={},url={}".format(str(wait),url))
            print " ",first_line
            _,sent = send(client, "HTTP/1.1 301 Moved Permanently\r\nConnection: keep-alive\r\nLocation: {}\r\nFooBar:".format(url))
            while 0<wait:
                _,sent = send(client, ".")
                print ".",
                time.sleep(1)
                wait = wait-1
            _,sent = send(client, "\r\n\r\n")
            log(address, start_time, id, "Client disconnected")
            client.close()

        #except IOError as e: #Exception as e:
        #    log(address, start_time, id, "Exception:: " + str(e))
        #    client.close()
        #    return False



if __name__ == "__main__":
    port_num = 1337 #input("Port? ")
    ThreadedServer('',port_num).listen()
